diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicOreRedstone.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicOreRedstone.java
index 606dda590..7721943c7 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicOreRedstone.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicOreRedstone.java
@@ -65,15 +65,15 @@ public class BlockLogicOreRedstone extends BlockLogic {
     private void lightRedstone(@NotNull World world, @NotNull TilePosc tilePos) {
         spawnParticles(world, tilePos);
         if (!this.illuminated) {
-            world.scheduleBlockUpdate(tilePos, this.illuminatedBlock.id(), 20 + world.rand.nextInt(9 * 20));
-            world.setBlockIdNotify(tilePos, this.illuminatedBlock.id());
+            world.scheduleBlockUpdate(tilePos, this.illuminatedBlock, 20 + world.rand.nextInt(9 * 20));
+            world.setBlockTypeNotify(tilePos, this.illuminatedBlock);
         }
     }
 
     @Override
     public void updateTick(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Random rand, boolean isRandomTick) {
         if (this.illuminated) {
-            world.setBlockIdNotify(tilePos, this.normalBlock.id());
+            world.setBlockTypeNotify(tilePos, this.normalBlock);
         }
     }
 
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicOverlayPebbles.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicOverlayPebbles.java
index 64a0ff38c..6305aa3ed 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicOverlayPebbles.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicOverlayPebbles.java
@@ -35,7 +35,7 @@ public class BlockLogicOverlayPebbles extends BlockLogic {
 
     @Override
     public boolean canPlaceAt(@NotNull World world, @NotNull TilePosc tilePos) {
-        Block<?> block = world.getBlock(tilePos.down(new TilePos()));
+        Block<?> block = world.getBlockType(tilePos.down(new TilePos()));
         return block != null && block.getMaterial().isSolid();
     }
 
@@ -55,10 +55,10 @@ public class BlockLogicOverlayPebbles extends BlockLogic {
     }
 
     @Override
-    public void onNeighborChanged(@NotNull World world, @NotNull TilePosc tilePos, int id) {
+    public void onNeighborChanged(@NotNull World world, @NotNull TilePosc tilePos, final @NotNull Block<?> block) {
         if (!canStay(world, tilePos)) {
             dropWithCause(world, EnumDropCause.WORLD, tilePos, world.getBlockData(tilePos), null, null);
-            world.setBlockIdNotify(tilePos, 0);
+            world.setBlockTypeNotify(tilePos, Blocks.AIR);
         }
     }
 
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicPathDirt.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicPathDirt.java
index 3077d4b15..ac4241ffa 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicPathDirt.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicPathDirt.java
@@ -38,13 +38,13 @@ public class BlockLogicPathDirt extends BlockLogic {
     }
 
     @Override
-    public void onNeighborChanged(@NotNull World world, @NotNull TilePosc tilePos, int id) {
-        super.onNeighborChanged(world, tilePos, id);
+    public void onNeighborChanged(@NotNull World world, @NotNull TilePosc tilePos, final @NotNull Block<?> block) {
+        super.onNeighborChanged(world, tilePos, block);
         TilePos up = tilePos.up(new TilePos());
         Material material = world.getBlockMaterial(up);
-        Block<?> b = world.getBlock(up);
+        Block<?> b = world.getBlockType(up);
         if (material.isSolid() && b != Blocks.FENCE_GATE_PLANKS_OAK && b != Blocks.FENCE_GATE_PLANKS_OAK_PAINTED && b != Blocks.SIGN_WALL_PLANKS_OAK) {
-            world.setBlockIdNotify(tilePos, Blocks.DIRT.id());
+            world.setBlockTypeNotify(tilePos, Blocks.DIRT);
         }
     }
 
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicPlanks.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicPlanks.java
index 51223d2ea..9d5ab5549 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicPlanks.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicPlanks.java
@@ -13,7 +13,7 @@ public class BlockLogicPlanks extends BlockLogic implements IPaintable {
 
     @Override
     public void setColor(@NotNull World world, @NotNull TilePosc tilePos, @NotNull DyeColor color) {
-        world.setBlockId(tilePos, Blocks.PLANKS_OAK_PAINTED.id());
+        world.setBlockType(tilePos, Blocks.PLANKS_OAK_PAINTED);
         Blocks.PLANKS_OAK_PAINTED.getLogic().setColor(world, tilePos, color);
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicPlanksPainted.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicPlanksPainted.java
index 2dfba223b..60d30cd09 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicPlanksPainted.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicPlanksPainted.java
@@ -47,7 +47,7 @@ public class BlockLogicPlanksPainted extends BlockLogic implements IPainted
 
     @Override
     public void removeDye(@NotNull World world, @NotNull TilePosc tilePos) {
-        world.setBlockIdNotify(tilePos, Blocks.PLANKS_OAK.id());
+        world.setBlockTypeNotify(tilePos, Blocks.PLANKS_OAK);
     }
 
     @Override
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicPortal.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicPortal.java
index e9be8f585..078026940 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicPortal.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicPortal.java
@@ -98,7 +98,7 @@ public class BlockLogicPortal extends BlockLogicTransparent implements IPainted
 
         // Sink to minimum Y
         for (int ry = 0; ry > -maxDims; ry--) {
-            if (world.getBlockId(tempPos.set(p.x, p.y + ry, p.z)) == this.portalFrame.id()) {
+            if (world.getBlockType(tempPos.set(p.x, p.y + ry, p.z)) == this.portalFrame) {
                 foundBottom = true;
                 p.y += ry;
                 break;
@@ -112,7 +112,7 @@ public class BlockLogicPortal extends BlockLogicTransparent implements IPainted
         if (!swapOrientation) {
             // Find orientation and minimum bound
             for (int rx = 0; rx > -maxDims; rx--) {
-                if (world.getBlockId(tempPos.set(p.x + rx, p.y, p.z)) == this.portalFrame.id()) {
+                if (world.getBlockType(tempPos.set(p.x + rx, p.y, p.z)) == this.portalFrame) {
                     axis = Axis.X;
                     p.x += rx;
                     break;
@@ -121,7 +121,7 @@ public class BlockLogicPortal extends BlockLogicTransparent implements IPainted
 
             if (axis == Axis.NONE) {
                 for (int rz = 0; rz > -maxDims; rz--) {
-                    if (world.getBlockId(tempPos.set(p.x, p.y, p.z + rz)) == this.portalFrame.id()) {
+                    if (world.getBlockType(tempPos.set(p.x, p.y, p.z + rz)) == this.portalFrame) {
                         axis = Axis.Z;
                         p.z += rz;
                         break;
@@ -131,7 +131,7 @@ public class BlockLogicPortal extends BlockLogicTransparent implements IPainted
         } else {
             // Find orientation and minimum bound
             for (int rz = 0; rz > -maxDims; rz--) {
-                if (world.getBlockId(tempPos.set(p.x, p.y, p.z + rz)) == this.portalFrame.id()) {
+                if (world.getBlockType(tempPos.set(p.x, p.y, p.z + rz)) == this.portalFrame) {
                     axis = Axis.Z;
                     p.z += rz;
                     break;
@@ -140,7 +140,7 @@ public class BlockLogicPortal extends BlockLogicTransparent implements IPainted
 
             if (axis == Axis.NONE) {
                 for (int rx = 0; rx > -maxDims; rx--) {
-                    if (world.getBlockId(tempPos.set(p.x + rx, p.y, p.z)) == this.portalFrame.id()) {
+                    if (world.getBlockType(tempPos.set(p.x + rx, p.y, p.z)) == this.portalFrame) {
                         axis = Axis.X;
                         p.x += rx;
                         break;
@@ -156,7 +156,7 @@ public class BlockLogicPortal extends BlockLogicTransparent implements IPainted
             case X: {
                 // Find in X direction
                 for (int rx = 1; rx < maxDims; rx++) {
-                    if (world.getBlockId(tempPos.set(p.x + rx, p.y, p.z)) == this.portalFrame.id()) {
+                    if (world.getBlockType(tempPos.set(p.x + rx, p.y, p.z)) == this.portalFrame) {
                         maxBoundA = rx;
                         break;
                     }
@@ -167,7 +167,7 @@ public class BlockLogicPortal extends BlockLogicTransparent implements IPainted
             default: {
                 // Find in Z direction
                 for (int rz = 1; rz < maxDims; rz++) {
-                    if (world.getBlockId(tempPos.set(p.x, p.y, p.z + rz)) == this.portalFrame.id()) {
+                    if (world.getBlockType(tempPos.set(p.x, p.y, p.z + rz)) == this.portalFrame) {
                         maxBoundA = rz;
                         break;
                     }
@@ -186,7 +186,7 @@ public class BlockLogicPortal extends BlockLogicTransparent implements IPainted
             if (p.y + ry >= world.getHeightBlocks())
                 return swapOrientation ? null : getPortalDims(world, tilePos, true, expectMiddle);
 
-            if (world.getBlockId(tempPos.set(p.x + (axis == Axis.X ? 1 : 0), p.y + ry, p.z + (axis == Axis.Z ? 1 : 0))) == this.portalFrame.id()) {
+            if (world.getBlockType(tempPos.set(p.x + (axis == Axis.X ? 1 : 0), p.y + ry, p.z + (axis == Axis.Z ? 1 : 0))) == this.portalFrame) {
                 maxBoundY = ry;
                 break;
             }
@@ -200,14 +200,14 @@ public class BlockLogicPortal extends BlockLogicTransparent implements IPainted
             for (int ry = 0; ry <= maxBoundY; ry++) {
                 // Check edges are correct
                 if (ra == 0 || ra == maxBoundA || ry == 0 || ry == maxBoundY) {
-                    if (world.getBlockId(tempPos.set(p.x + (axis == Axis.X ? ra : 0), p.y + ry, p.z + (axis == Axis.Z ? ra : 0))) != this.portalFrame.id()) {
+                    if (world.getBlockType(tempPos.set(p.x + (axis == Axis.X ? ra : 0), p.y + ry, p.z + (axis == Axis.Z ? ra : 0))) != this.portalFrame) {
                         return swapOrientation ? null : getPortalDims(world, tilePos, true, expectMiddle);
                     }
                 } else // Check interior is empty/fire
                 {
-                    int id = world.getBlockId(tempPos.set(p.x + (axis == Axis.X ? ra : 0), p.y + ry, p.z + (axis == Axis.Z ? ra : 0)));
+                    final @NotNull Block<?> block = world.getBlockType(tempPos.set(p.x + (axis == Axis.X ? ra : 0), p.y + ry, p.z + (axis == Axis.Z ? ra : 0)));
 
-                    if (id != 0 && id != this.portalTrigger.id() && id != this.block.id()) {
+                    if (block != Blocks.AIR && block != this.portalTrigger && block != this.block) {
                         return swapOrientation ? null : getPortalDims(world, tilePos, true, expectMiddle);
                     }
                 }
@@ -218,9 +218,9 @@ public class BlockLogicPortal extends BlockLogicTransparent implements IPainted
         if (expectMiddle) {
             for (int ra = 1; ra < maxBoundA; ra++) {
                 for (int ry = 1; ry < maxBoundY; ry++) {
-                    int id = world.getBlockId(tempPos.set(p.x + (axis == Axis.X ? ra : 0), p.y + ry, p.z + (axis == Axis.Z ? ra : 0)));
+                    final @NotNull Block<?> block = world.getBlockType(tempPos.set(p.x + (axis == Axis.X ? ra : 0), p.y + ry, p.z + (axis == Axis.Z ? ra : 0)));
 
-                    if (id != this.block.id()) {
+                    if (block != this.block) {
                         return swapOrientation ? null : getPortalDims(world, tilePos, true, true);
                     }
                 }
@@ -246,7 +246,7 @@ public class BlockLogicPortal extends BlockLogicTransparent implements IPainted
                         p.x = bounds.pos.x + ra;
                         p.y = bounds.pos.y + ry;
                         p.z = bounds.pos.z;
-                        world.setBlockIdData(p, this.block.id(), ORIENTATION_X & 0x1);
+                        world.setBlockTypeData(p, this.block, ORIENTATION_X & 0x1);
                     }
                 }
 
@@ -266,7 +266,7 @@ public class BlockLogicPortal extends BlockLogicTransparent implements IPainted
                         p.x = bounds.pos.x;
                         p.y = bounds.pos.y + ry;
                         p.z = bounds.pos.z + ra;
-                        world.setBlockIdData(p, this.block.id(), ORIENTATION_Z & 0x1);
+                        world.setBlockTypeData(p, this.block, ORIENTATION_Z & 0x1);
                     }
 
                 }
@@ -287,11 +287,11 @@ public class BlockLogicPortal extends BlockLogicTransparent implements IPainted
     }
 
     @Override
-    public void onNeighborChanged(@NotNull World world, @NotNull TilePosc tilePos, int id) {
+    public void onNeighborChanged(@NotNull World world, @NotNull TilePosc tilePos, final @NotNull Block<?> block) {
         Bounds bounds = getPortalDims(world, tilePos, true);
 
         if (bounds == null) {
-            world.setBlockIdNotify(tilePos, 0);
+            world.setBlockTypeNotify(tilePos, Blocks.AIR);
         }
     }
 
@@ -334,7 +334,7 @@ public class BlockLogicPortal extends BlockLogicTransparent implements IPainted
             double xd = (rand.nextDouble() - 0.5D) * 0.5D;
             double yd = (rand.nextDouble() - 0.5D) * 0.5D;
             double zd = (rand.nextDouble() - 0.5D) * 0.5D;
-            if (world.getBlockId(tilePos.add(Direction.WEST, queryPos)) == this.block.id() || world.getBlockId(tilePos.add(Direction.EAST, queryPos)) == this.block.id()) {
+            if (world.getBlockType(tilePos.add(Direction.WEST, queryPos)) == this.block || world.getBlockType(tilePos.add(Direction.EAST, queryPos)) == this.block) {
                 pz = (double) tilePos.z() + 0.5D + 0.25D * (double) i1;
                 zd = rand.nextFloat() * 2.0D * (double) i1;
             } else {
@@ -365,7 +365,7 @@ public class BlockLogicPortal extends BlockLogicTransparent implements IPainted
     @Override
     public void removeDye(@NotNull World world, @NotNull TilePosc tilePos) {
         final int meta = world.getBlockData(tilePos);
-        world.setBlockIdDataNotify(tilePos, Blocks.STAIRS_PLANKS_OAK.id(), stripColorFromMetadata(meta));
+        world.setBlockDataNotify(tilePos, stripColorFromMetadata(meta));
     }
 
     @Override
@@ -378,7 +378,7 @@ public class BlockLogicPortal extends BlockLogicTransparent implements IPainted
     public void setColor(@NotNull World world, @NotNull TilePosc tilePos, @NotNull DyeColor color) {
         Bounds bounds = getPortalDims(world, tilePos, true);
         if (bounds == null) {
-            world.setBlockIdNotify(tilePos, 0);
+            world.setBlockTypeNotify(tilePos, Blocks.AIR);
             return;
         }
 
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicPressurePlate.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicPressurePlate.java
index a246074d2..5a0ab3cdd 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicPressurePlate.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicPressurePlate.java
@@ -71,10 +71,10 @@ public class BlockLogicPressurePlate<T extends Entity> extends BlockLogic implem
     }
 
     @Override
-    public void onNeighborChanged(@NotNull World world, @NotNull TilePosc tilePos, int id) {
+    public void onNeighborChanged(@NotNull World world, @NotNull TilePosc tilePos, final @NotNull Block<?> block) {
         if (!isSupported(world, tilePos, sideFromMeta(world.getBlockData(tilePos)))) {
             dropWithCause(world, EnumDropCause.WORLD, tilePos, world.getBlockData(tilePos), null, null);
-            world.setBlockIdNotify(tilePos, 0);
+            world.setBlockTypeNotify(tilePos, Blocks.AIR);
         }
     }
 
@@ -135,19 +135,19 @@ public class BlockLogicPressurePlate<T extends Entity> extends BlockLogic implem
         }
         if (isSteppedOn && !isPressed) {
             world.setBlockDataNotify(tilePos, meta | MASK_POWERED);
-            world.notifyBlocksOfNeighborChange(tilePos, id());
-            world.notifyBlocksOfNeighborChange(tilePos.add(dir, new TilePos()), id());
+            world.notifyBlocksOfNeighborChange(tilePos, this.block);
+            world.notifyBlocksOfNeighborChange(tilePos.add(dir, new TilePos()), this.block);
             world.markBlocksDirty(tilePos, tilePos);
             world.playSoundEffect(null, SoundCategory.WORLD_SOUNDS, (double) tilePos.x() + 0.5D, (double) tilePos.y() + 0.1D, (double) tilePos.z() + 0.5D, "random.click", 0.3F, 0.6F);
         } else if (!isSteppedOn && isPressed) {
             world.setBlockDataNotify(tilePos, meta & ~MASK_POWERED);
-            world.notifyBlocksOfNeighborChange(tilePos, id());
-            world.notifyBlocksOfNeighborChange(tilePos.add(dir, new TilePos()), id());
+            world.notifyBlocksOfNeighborChange(tilePos, this.block);
+            world.notifyBlocksOfNeighborChange(tilePos.add(dir, new TilePos()), this.block);
             world.markBlocksDirty(tilePos, tilePos);
             world.playSoundEffect(null, SoundCategory.WORLD_SOUNDS, (double) tilePos.x() + 0.5D, (double) tilePos.y() + 0.1D, (double) tilePos.z() + 0.5D, "random.click", 0.3F, 0.5F);
         }
         if (isSteppedOn) {
-            world.scheduleBlockUpdate(tilePos, id(), tickDelay());
+            world.scheduleBlockUpdate(tilePos, this.block, tickDelay());
         }
     }
 
@@ -155,8 +155,8 @@ public class BlockLogicPressurePlate<T extends Entity> extends BlockLogic implem
     public void onRemoved(@NotNull World world, @NotNull TilePosc tilePos, int data) {
         if (isPressed(data)) {
             Side side = sideFromMeta(world.getBlockData(tilePos));
-            world.notifyBlocksOfNeighborChange(tilePos, id());
-            world.notifyBlocksOfNeighborChange(tilePos.add(side.getDirection(), new TilePos()), id());
+            world.notifyBlocksOfNeighborChange(tilePos, this.block);
+            world.notifyBlocksOfNeighborChange(tilePos.add(side.getDirection(), new TilePos()), this.block);
         }
         super.onRemoved(world, tilePos, data);
     }
@@ -224,24 +224,24 @@ public class BlockLogicPressurePlate<T extends Entity> extends BlockLogic implem
             world.setBlockData(tilePos, setSide(meta, side));
         } else {
             dropWithCause(world, EnumDropCause.WORLD, tilePos, meta, null, null);
-            world.setBlockIdNotify(tilePos, 0);
+            world.setBlockTypeNotify(tilePos, Blocks.AIR);
         }
 
     }
 
     @Override
     public boolean canBePainted() {
-        return id() == Blocks.PRESSURE_PLATE_PLANKS_OAK.id();
+        return this.block == Blocks.PRESSURE_PLATE_PLANKS_OAK;
     }
 
     @Override
     public void setColor(@NotNull World world, @NotNull TilePosc tilePos, @NotNull DyeColor color) {
         final int meta = world.getBlockData(tilePos);
-        world.setBlockIdDataRaw(tilePos, Blocks.PRESSURE_PLATE_PLANKS_OAK_PAINTED.id(), meta);
+        world.setBlockTypeDataRaw(tilePos, Blocks.PRESSURE_PLATE_PLANKS_OAK_PAINTED, meta);
         world.setBlockData(tilePos, meta);
         Blocks.PRESSURE_PLATE_PLANKS_OAK_PAINTED.getLogic().setColor(world, tilePos, color);
         if (isPressed(meta)) {
-            world.scheduleBlockUpdate(tilePos, Blocks.PRESSURE_PLATE_PLANKS_OAK_PAINTED.id(), tickDelay());
+            world.scheduleBlockUpdate(tilePos, Blocks.PRESSURE_PLATE_PLANKS_OAK_PAINTED, tickDelay());
         }
     }
 
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicPressurePlatePainted.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicPressurePlatePainted.java
index be23d76c8..710a8a884 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicPressurePlatePainted.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicPressurePlatePainted.java
@@ -46,7 +46,7 @@ public class BlockLogicPressurePlatePainted<T extends Entity> extends BlockLogic
 
     @Override
     public void removeDye(@NotNull World world, @NotNull TilePosc tilePos) {
-        world.setBlockIdNotify(tilePos, Blocks.PRESSURE_PLATE_PLANKS_OAK.id());
+        world.setBlockTypeNotify(tilePos, Blocks.PRESSURE_PLATE_PLANKS_OAK);
     }
 
     @Override
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicPumice.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicPumice.java
index 4469a97e8..c1cbb98a1 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicPumice.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicPumice.java
@@ -25,7 +25,7 @@ public class BlockLogicPumice extends BlockLogic {
         super.onPlacedByWorld(world, tilePos);
         byte radius = 2;
         if (this.isWet && (inWater(world, tilePos) || world.dimension.id == Dimension.DRIFT.id)) {
-            world.setBlockIdNotify(tilePos, Blocks.PUMICE_DRY.id());
+            world.setBlockTypeNotify(tilePos, Blocks.PUMICE_DRY);
             world.playSoundEffect(null, SoundCategory.WORLD_SOUNDS, tilePos.x() + 0.5D, tilePos.y() + 0.5D, tilePos.z() + 0.5D, "random.fizz", 0.5F, 2.6F + (world.rand.nextFloat() - world.rand.nextFloat()) * 0.8F);
             for (int l = 0; l < 8; l++) {
                 world.spawnParticle("largesmoke", (double) tilePos.x() + Math.random(), (double) tilePos.y() + Math.random(), (double) tilePos.z() + Math.random(), 0.0D, 0.0D, 0.0D, 0);
@@ -36,13 +36,13 @@ public class BlockLogicPumice extends BlockLogic {
             for (queryPos.x = tilePos.x() - radius; queryPos.x <= tilePos.x() + radius; queryPos.x++) {
                 for (queryPos.y = tilePos.y() - radius; queryPos.y <= tilePos.y() + radius; queryPos.y++) {
                     for (queryPos.z = tilePos.z() - radius; queryPos.z <= tilePos.z() + radius; queryPos.z++) {
-                        if (Blocks.hasTag(world.getBlockId(queryPos), BlockTags.IS_LAVA)) {
-                            world.setBlockIdNotify(queryPos, 0);
+                        if (world.getBlockType(queryPos).hasTag(BlockTags.IS_LAVA)) {
+                            world.setBlockTypeNotify(queryPos, Blocks.AIR);
                         }
                     }
                 }
             }
-            world.setBlockIdNotify(tilePos, Blocks.PUMICE_WET.id());
+            world.setBlockTypeNotify(tilePos, Blocks.PUMICE_WET);
         }
     }
 
@@ -50,23 +50,23 @@ public class BlockLogicPumice extends BlockLogic {
     public boolean inLava(@NotNull World world, @NotNull TilePosc tilePos) {
         TilePos queryPos = new TilePos();
         return
-            Blocks.hasTag(world.getBlockId(tilePos.east(queryPos)), BlockTags.IS_LAVA) ||
-                Blocks.hasTag(world.getBlockId(tilePos.west(queryPos)), BlockTags.IS_LAVA) ||
-                Blocks.hasTag(world.getBlockId(tilePos.up(queryPos)), BlockTags.IS_LAVA) ||
-                Blocks.hasTag(world.getBlockId(tilePos.down(queryPos)), BlockTags.IS_LAVA) ||
-                Blocks.hasTag(world.getBlockId(tilePos.south(queryPos)), BlockTags.IS_LAVA) ||
-                Blocks.hasTag(world.getBlockId(tilePos.north(queryPos)), BlockTags.IS_LAVA);
+            world.getBlockType(tilePos.east(queryPos)).hasTag(BlockTags.IS_LAVA) ||
+            world.getBlockType(tilePos.west(queryPos)).hasTag(BlockTags.IS_LAVA) ||
+            world.getBlockType(tilePos.up(queryPos)).hasTag(BlockTags.IS_LAVA) ||
+            world.getBlockType(tilePos.down(queryPos)).hasTag(BlockTags.IS_LAVA) ||
+            world.getBlockType(tilePos.south(queryPos)).hasTag(BlockTags.IS_LAVA) ||
+            world.getBlockType(tilePos.north(queryPos)).hasTag(BlockTags.IS_LAVA);
     }
 
     public boolean inWater(@NotNull World world, @NotNull TilePosc tilePos) {
         TilePos queryPos = new TilePos();
         return
-            Blocks.hasTag(world.getBlockId(tilePos.east(queryPos)), BlockTags.IS_WATER) ||
-                Blocks.hasTag(world.getBlockId(tilePos.west(queryPos)), BlockTags.IS_WATER) ||
-                Blocks.hasTag(world.getBlockId(tilePos.up(queryPos)), BlockTags.IS_WATER) ||
-                Blocks.hasTag(world.getBlockId(tilePos.down(queryPos)), BlockTags.IS_WATER) ||
-                Blocks.hasTag(world.getBlockId(tilePos.south(queryPos)), BlockTags.IS_WATER) ||
-                Blocks.hasTag(world.getBlockId(tilePos.north(queryPos)), BlockTags.IS_WATER);
+            world.getBlockType(tilePos.east(queryPos)).hasTag(BlockTags.IS_WATER) ||
+            world.getBlockType(tilePos.west(queryPos)).hasTag(BlockTags.IS_WATER) ||
+            world.getBlockType(tilePos.up(queryPos)).hasTag(BlockTags.IS_WATER) ||
+            world.getBlockType(tilePos.down(queryPos)).hasTag(BlockTags.IS_WATER) ||
+            world.getBlockType(tilePos.south(queryPos)).hasTag(BlockTags.IS_WATER) ||
+            world.getBlockType(tilePos.north(queryPos)).hasTag(BlockTags.IS_WATER);
     }
 
     @Override
@@ -77,7 +77,7 @@ public class BlockLogicPumice extends BlockLogic {
             for (queryPos.x = tilePos.x() - radius; queryPos.x <= tilePos.x() + radius; queryPos.x++) {
                 for (queryPos.y = tilePos.y() - radius; queryPos.y <= tilePos.y() + radius; queryPos.y++) {
                     for (queryPos.z = tilePos.z() - radius; queryPos.z <= tilePos.z() + radius; queryPos.z++) {
-                        world.notifyBlocksOfNeighborChange(queryPos, world.getBlockId(queryPos));
+                        world.notifyBlocksOfNeighborChange(queryPos, world.getBlockType(queryPos));
                     }
 
                 }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicPumpkin.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicPumpkin.java
index ec8d659db..b54fa7cf8 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicPumpkin.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicPumpkin.java
@@ -30,7 +30,7 @@ public class BlockLogicPumpkin extends BlockLogicVeryRotatable
         ItemStack heldItem = player.getHeldItem();
         if (heldItem != null && heldItem.getItem() instanceof ItemToolSword){
             heldItem.damageItem(1,player);
-            world.setBlockIdDataNotify(tilePos, Blocks.PUMPKIN_CARVED_IDLE.id(), player.getHorizontalPlacementDirection(Direction.getHorizontalDirection(player).getSide()).getOpposite().getId());
+            world.setBlockTypeDataNotify(tilePos, Blocks.PUMPKIN_CARVED_IDLE, player.getHorizontalPlacementDirection(Direction.getHorizontalDirection(player).getSide()).getOpposite().getId());
             return true;
         }
         return false;
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicPumpkinRedstone.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicPumpkinRedstone.java
index 67112f100..381ab4251 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicPumpkinRedstone.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicPumpkinRedstone.java
@@ -20,7 +20,7 @@ public class BlockLogicPumpkinRedstone extends BlockLogicVeryRotatable {
     public void onPlacedByWorld(@NotNull World world, @NotNull TilePosc tilePos) {
         TilePos queryPos = new TilePos();
         for (Direction dir : Direction.directions){
-            world.notifyBlocksOfNeighborChange(tilePos.add(dir, queryPos), id());
+            world.notifyBlocksOfNeighborChange(tilePos.add(dir, queryPos), this.block);
         }
     }
 
@@ -28,7 +28,7 @@ public class BlockLogicPumpkinRedstone extends BlockLogicVeryRotatable {
     public void onRemoved(@NotNull World world, @NotNull TilePosc tilePos, int data) {
         TilePos queryPos = new TilePos();
         for (Direction dir : Direction.directions){
-            world.notifyBlocksOfNeighborChange(tilePos.add(dir, queryPos), id());
+            world.notifyBlocksOfNeighborChange(tilePos.add(dir, queryPos), this.block);
         }
     }
 
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicRail.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicRail.java
index 6f48849b8..029969654 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicRail.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicRail.java
@@ -88,12 +88,12 @@ public class BlockLogicRail extends BlockLogic implements ISupportable {
     public void onPlacedByWorld(@NotNull World world, @NotNull TilePosc tilePos) {
         performRailTurn(world, tilePos, true);
         if (this.block == Blocks.RAIL_POWERED) {
-            onNeighborChanged(world, tilePos, id());
+            onNeighborChanged(world, tilePos, this.block);
         }
     }
 
     @Override
-    public void onNeighborChanged(@NotNull World world, @NotNull TilePosc tilePos, int id) {
+    public void onNeighborChanged(@NotNull World world, @NotNull TilePosc tilePos, final @NotNull Block<?> block) {
         if (world.isClientSide) {
             return;
         }
@@ -103,7 +103,7 @@ public class BlockLogicRail extends BlockLogic implements ISupportable {
 
         if (!isSupported(world, tilePos, Side.BOTTOM)) {
             dropWithCause(world, EnumDropCause.WORLD, tilePos, world.getBlockData(tilePos), null, null);
-            world.setBlockIdNotify(tilePos, 0);
+            world.setBlockTypeNotify(tilePos, Blocks.AIR);
             return;
         } else if (!isRailValid(world, tilePos)) {
             switch (railDirection) {
@@ -122,8 +122,6 @@ public class BlockLogicRail extends BlockLogic implements ISupportable {
             }
         }
 
-        Block<?> block = Blocks.getBlock(id);
-
         if (this.block == Blocks.RAIL_POWERED) {
             TilePos queryPos = new TilePos();
 
@@ -145,9 +143,9 @@ public class BlockLogicRail extends BlockLogic implements ISupportable {
             }
 
             if (changedMeta) {
-                world.notifyBlocksOfNeighborChange(tilePos.down(queryPos), id());
+                world.notifyBlocksOfNeighborChange(tilePos.down(queryPos), this.block);
                 if (railDirection.isSloped()) {
-                    world.notifyBlocksOfNeighborChange(tilePos.up(queryPos), id());
+                    world.notifyBlocksOfNeighborChange(tilePos.up(queryPos), this.block);
                 }
             }
         } else if (block != null && block.isSignalSource() && new Rail(world, tilePos).getAdjacentTracks() == 3) {
@@ -197,8 +195,8 @@ public class BlockLogicRail extends BlockLogic implements ISupportable {
     }
 
     private boolean isConnectedPoweredRail2(@NotNull World world, @NotNull TilePos tilePos, boolean forward, int distance, @NotNull Axis axis) {
-        int blockId = world.getBlockId(tilePos);
-        if (blockId == Blocks.RAIL_POWERED.id()) {
+        final @NotNull Block<?> block = world.getBlockType(tilePos);
+        if (block == Blocks.RAIL_POWERED) {
             int meta = world.getBlockData(tilePos);
             boolean isPoweredFlagSet = (meta & MASK_POWERED) != 0;
             RailDirection direction = getRailDirection(world, tilePos);
